;*****WINMAIN*******************************************************************
WMSTRUC STRUC
 msg MSG {}        ;message structure ****ALWAYS KEEP MSG STRUCTURE AT BEGINNING
WMSTRUC ENDS

MAIN:
 XOR EBP,EBP       ;handy constant zero
 SUB ESP,WMSTRUC   ;make local space

 INVOKE GetModuleHandleA,EBP

 MOV ESI,EAX       ;now ESI=module handle
 MOV [hInst],EAX   ;tuck it away

;*****CLASS REGISTRATION********************************************************
 RPUSHIT EBP,LBYTER(szAppName,'PRINT3',0)
 RPUSHIT COLOR_WINDOW+1                   ;for window background color
 INVOKE LoadCursor,EBP,IDC_ARROW
 RPUSHIT EAX                              ;cursor handle
 INVOKE LoadIcon,ESI,IDI_APPLICATION      ;ESI=hInst

 S1=CS_HREDRAW OR CS_VREDRAW
 RPUSHIT S1,@ WINCALLBACK,EBP,EBP,ESI,EAX ;ESI=hInst
 INVOKE RegisterClass,ESP

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,BYTER('Class registration failed.',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 ADD ESP,10*DWORD                        ;balance stack from WNDCLASS
;*****END OF CLASS REGISTRATION*************************************************
;*****WINDOW CREATION***********************************************************

 MOV ECX,CW_USEDEFAULT
 S1=WS_OVERLAPPEDWINDOW

 INVOKE CreateWindowExA,EBP,@ szAppName,BYTER('PRINT PROGRAM 3 (DIALOG BOX) TRANSCRIBED BY RATCH',0)\
                       ,S1,ECX,ECX,ECX,ECX,EBP,EBP,ESI,EBP ;EBP=0

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,BYTER('Main CreateWindow call error',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 MOV ESI,EAX                             ;now ESI=hwnd=window handle

;*****END OF WINDOW CREATION****************************************************

 INVOKE ShowWindow,ESI,SW_SHOWNORMAL

 INVOKE UpdateWindow,ESI

IF DBUG
 TEST EAX,EAX
 .IF ZERO?
   INVOKE MessageBox,ESI,BYTER('UpdateWindow call error',0),EBP,EBP ;EBP=0
   JMP EXIT
 .ENDIF
ENDIF

 MOV EBX,ESP        ;EBX=&msg

 .WHILE TRUE  ;beginning of message loop
   INVOKE GetMessageA,EBX,EBP,EBP,EBP ;
   TEST EAX,EAX

   IF DBUG
    JS GMERR        ;jump out on GetMessage error
   ELSE
    JS EXIT         ;jump out on GetMessage error
   ENDIF

   .BREAK .IF ZERO? ;jump out on WM_QUIT message

   INVOKE TranslateMessage,EBX ;EBX=&msg
   INVOKE DispatchMessageA,EBX ;EBX=&msg
 .ENDW              ;repeat message loop

 MOV EAX,[ESP.MSG.wParam]

EXIT:
 ADD ESP,MSG                   ;recover local space

 INVOKE ExitProcess,EAX

IF DBUG
GMERR:                         ;display error message via message box & jmp to EXIT
 INVOKE MessageBox,ESI,BYTER('GetMessage call error',0),EBP,EBP ;EBP=0
 JMP EXIT
ENDIF

;*****END OF WINMAIN************************************************************
